////////////////////////////////////////////////////////////////////////////
// Model MICEK2.CPP               SIMLIB/C++
//
// Skkajc mek (kombinovan model, varianta 2)
//

#include "simlib.h"

const unsigned MaxBang = 10;    // maximln poet odraz

// popis modelu:
//Problem!!! Constant g = 9.81;              // gravitan zrychlen
Constant g(9.81);               // gravitan zrychlen

struct Ball {                   // popis modelu mku
  unsigned count;               // poet odraz
  // detektor stavovch udlost:
  class LimitY : ConditionDown {
    Ball *b;
    void Action() { b->Bang(); }  // stavov udlost: posln zprvy
   public:
    LimitY(Ball *ball) :
      ConditionDown(ball->y),     // podmnka: (y>=0)  TRUE --> FALSE
      b(ball) {}
  } ylim;
  Integrator v,y;               // stav mku

  Ball(double initialposition) :
    count(0),
    ylim(this),                 // podmnka dopadu
    v(-g - v*0.1),              // popis volnho pdu:
    y(v, initialposition)  {}

  void Bang()  {                // stavov udlost - odraz mku
    Out();                      // tisk stavu pi dopadu
    Print("\n# Odraz %u\n", ++count);
    v = -0.9 * v.Value();       // ztrta energie
    y = 0;                      // toto je nutn z hlediska pesnosti!
    if(count>=MaxBang)          // maximln poet odraz
      Stop();                   //   konec simulace
    Out();                      // tisk novho stavu
  }
  void Out() {
    Print("%g  %g  %g\n", T.Value(), y.Value(), v.Value());
  }
};

Ball b1(10);                    // vytvoen modelu mku

void Sample() { b1.Out(); }     // vzorkovn stavu mku
Sampler S(Sample, 0.05);

int main() {                    // experiment
  // DebugON();
  SetOutput("micek2.dat");
  _Print("# MICEK2 - model skkajcho mku\n");
  Print("# Time y v \n");
  Init(0);                      // od asu 0
  SetStep(1e-10, 0.5);
  SetAccuracy(1e-5, 0.001);
  Run();                        // simulace
  return 0;
}

// konec
