////////////////////////////////////////////////////////////////////////////
// model2-timeout.cc              SIMLIB/C++
//
// Ukzkov model s netrplivmi poadavky
//

#include "simlib.h"

const int TIMEOUT = 20;
const int SERVICE = 10;

// deklarace globlnch objekt
Facility  Box("Linka");
Histogram Tabulka("Tabulka", 0, 1, SERVICE+TIMEOUT+1);
long ncount = 0;

class Timeout : public Event {
    Process *ptr;        // kter proces
  public:
    Timeout(double t, Process *p): ptr(p) {
      Activate(Time+t);  // kdy vypr timeout
    }
    void Behavior() {
//      ptr->Out();        // vyjmout z fronty 
      //ptr->Terminate();  // likvidace
      delete ptr;        // likvidace
      ncount++;          // poitadlo
      Cancel();          // konec udlosti (SIMLIB BUG)
    }
};

class Zakaznik : public Process { // tda zkaznk
  double Prichod;                 // atribut kadho zkaznka
  void Behavior() {               // --- popis chovn zkaznka ---
    Prichod = Time;               // as pchodu zkaznka
    Event *timeout = new Timeout(TIMEOUT,this); // nastavit timeout
    Seize(Box);                   // obsazen zazen Box
    delete timeout; // zruit neaktivovan timeout
    Wait(SERVICE);                     // obsluha
    Release(Box);                 // uvolnn
    Tabulka(Time-Prichod);        // doba obsluhy a ekn
  }
};

class Generator : public Event {  // genertor zkaznk
  void Behavior() {               // --- popis chovn genertoru ---
    (new Zakaznik)->Activate();   // nov zkaznk, aktivace v ase Time
    Activate(Time+Exponential(1e3/150));  // interval mezi pchody
  }
};

int main() {                 // popis experimentu s modelem
//DebugON();
  Print("model2-timeout -- pklad SIMLIB/C++\n");
  SetOutput("model2-timeout.out");
  Init(0,1000);              // inicializace experimentu, as bude 0..1000
  (new Generator)->Activate(); // genertor zkaznk, jeho aktivace
  Run();                     // simulace
  Print("Poet netrplivch zkaznk: %d \n", ncount);
  Box.Output();              // tisk vsledk
  Tabulka.Output();
  return 0;
}

// konec
