////////////////////////////////////////////////////////////////////////////
// test3D.cc
//

#include "simlib.h"
#include "simlib3D.h"


Constant3D   gravity(0,0,-9.81);  // gravitacni zrychleni
Value3D      inip(10,10,10);      // inicializace polohy
Value3D      iniv(1,1,1);         // inicializace rychlosti

struct Model {
  //const double m = 10;
  Integrator3D v;  // rychlost
  Integrator3D p;  // zrychleni
  Model(Input3D a, Value3D initial_p, Value3D initial_v) :
    v(gravity, initial_v),
    p(v, initial_p) {}    
};

////////////////////////////////////////////////////////////////////////////
Model m(gravity, inip, iniv);
////////////////////////////////////////////////////////////////////////////

void fce() {
  Print("%3g: ", Time);
  Print("pos="); m.p.Print();
  Print(", v="); m.v.Print();
  Print("\n");
}

Sampler s(fce,0.1);

////////////////////////////////////////////////////////////////////////////
int main() // text
{
   SetOutput("test3D.out");
   _Print("# test3D \n");
   Init(0,5);
   SetStep(0.01,0.1);
   Run();
   return 0;
}
////////////////////////////////////////////////////////////////////////////

