/////////////////////////////////////////////////////////////////////////////
// ni_euler.h
//
// SIMLIB version: 2.18
// Date: 2004-01-25
//
// Copyright (c) 1996-1997 David Leska
// Copyright (c) 1998-2004 Petr Peringer 
//
// This library is licensed under GNU Library GPL. See the file COPYING.
//

//
//  numerical integration: Euler's method
//


#include "simlib.h"


////////////////////////////////////////////////////////////////////////////
//  class representing the integration method
//
class EULER : public StatusMethod {
private:
  Memory si, di, A;  // auxiliary memories
  StatusMemory xi;
public:
  EULER(const char* name) :  // registrate method and name it
    StatusMethod(name)
  { /*NOTHING*/ }
  virtual ~EULER()  // destructor
  { /*NOTHING*/ }
  virtual void Integrate(void);  // integration method
}; // class EULER


// end of ni_euler.h

