/////////////////////////////////////////////////////////////////////////////
// ni_rke.h
//
// SIMLIB version: 2.18
// Date: 2004-01-25
//
// Copyright (c) 1996-1997 David Leska
// Copyright (c) 1998-2004 Petr Peringer 
//
// This library is licensed under GNU Library GPL. See the file COPYING.
//

//
//  numerical integration: Runge-Kutta-England's method
//


#include "simlib.h"


////////////////////////////////////////////////////////////////////////////
//  class representing the integration method
//
class RKE : public StatusMethod {
private:
  Memory A1, A2, A3, A4, A5, A6, A7;  // auxiliary memories
  Memory si, di;
  StatusMemory xi;
public:
  RKE(const char* name) :  // registrate method and name it
    StatusMethod(name)
  { /*NOTHING*/ }
  virtual ~RKE()  // destructor
  { /*NOTHING*/ }
  virtual void Integrate(void);  // integration method
}; // class RKE


// end of ni_rke.h

